#include <time.h>
#include "../includes/prompt_and_read.h"
#include "../includes/allocation.h"

int main(void) {

	srand48(time(0));
	int rows = prompt_and_read_int("Enter #rows");
	int cols = prompt_and_read_int("Enter #cols");

	// allocate memory for the array
	int *array_2d = allocate(rows * cols * sizeof(int));

	//allocate vector of pointers to rows
	int** row_pointer = allocate(rows * sizeof(int*));
	row_pointer[0] = array_2d;
	for (int i = 1; i < rows; i++) {
		row_pointer[i] = row_pointer[i - 1] + cols;
	}

	for (int i = 0; i < rows; i++) {
		for (int j = 0; j < cols; j++) {
			row_pointer[i][j] = (int) (lrand48() % 100);
		}
	}

	for (int i = 0; i < rows; i++) {
		for (int j = 0; j < cols; j++) {
			printf("%4d ", row_pointer[i][j]);
		}
		printf("\n");
	}
	printf("\n");

	for (int i = 0; i < rows; i++) {
		for (int j = 0; j < cols; j++) {
			printf("%p ", &row_pointer[i][j]);
		}
		printf("\n");
	}

	// free memory
	free(array_2d);
	free(row_pointer);

	return EXIT_SUCCESS;
}

