#include "../includes/prompt_and_read.h"
#include "../includes/allocation.h"

int main(void) {

	int rows = prompt_and_read_int("Enter #rows");
	// allocate vector of pointers to rows
	int **arr2d = allocate(rows * sizeof(int*));
	// allocate vector of rows' lengths
	int *row_lengths = allocate(rows * sizeof(int));

	for (int i = 0; i < rows; i++) {
		int cols = prompt_and_read_int("Enter length of the row");
		row_lengths[i] = cols;
		// allocate i-th row
		arr2d[i] = (int*) allocate(cols * sizeof(int));
		for (int j = 0; j < cols; j++) {
			arr2d[i][j] = cols * i + j + 1;
		}
	}
	printf("\n");

	for (int i = 0; i < rows; i++) {
		printf("row %d: [ ", i+1);
		for (int j = 0; j < row_lengths[i]; j++) {
			printf("%d ", arr2d[i][j]);
		}
		printf("]\n");
	}

	// free memory
	for (int i = 0; i < rows; i++) {
		free(arr2d[i]);
	}
	free(arr2d);
	free(row_lengths);

	return EXIT_SUCCESS;
}

