#include "../includes/prompt_and_read.h"
#include "../includes/allocation.h"

int main(void) {
	int rows = prompt_and_read_int("Enter #rows");
	int cols = prompt_and_read_int("Enter #columns");

	// allocate vector of pointers to rows
	int **array_2d = allocate(rows * sizeof(int*));
	for (int i = 0; i < rows; i++) {
		// allocate i-th row
		array_2d[i] = allocate(cols * sizeof(int));
		for (int j = 0; j < cols; j++) {
			array_2d[i][j] = cols * i + j + 1;
		}
	}
	printf("\n");

	for (int i = 0; i < rows; i++) {
		for (int j = 0; j < cols; j++) {
			printf("%4d ", array_2d[i][j]);
		}
		printf("\n");
	}

	// free memory
	for (int i = 0; i < rows; i++) {
		free(array_2d[i]);
	}
	free(array_2d);

	return EXIT_SUCCESS;
}

