#include <stdlib.h>
#include "../includes/prompt_and_read.h"
#include "../includes/allocation.h"

void reverse(int*, int);
void print_array(int*, int);

int main(void) {

	int *int_ptr = allocate(sizeof(int)); // allocate space for an int
	*int_ptr = 1001;	//	store an int value there
	printf("int value = %d, location = %p\n", *int_ptr, int_ptr);
	printf("size of int_ptr = %zu, size of *int_ptr = %zu\n",
		sizeof(int_ptr), sizeof(*int_ptr));
	printf("\n");
	free(int_ptr);

	double* double_ptr = allocate(sizeof(double)); // allocate space for a double
	*double_ptr = 10000001.0; // store a double there
	printf("double value = %f, location = %p\n", *double_ptr, double_ptr);
	printf("size of double_ptr = %zu, size of *double_ptr = %zu\n",
		sizeof(double_ptr), sizeof(*double_ptr));
	printf("\n");
	free(double_ptr);

	int size = prompt_and_read_int("Enter array size");
	//	allocate integer array of size 'size'
	int *ptr_to_array = allocate(size * sizeof(int));
	for (int i = 0; i < size; i++) {
		ptr_to_array[i] = i + 3;
	}
	print_array(ptr_to_array, size);
	reverse(ptr_to_array, size);
	print_array(ptr_to_array, size);
	free(ptr_to_array); // free memory

	return EXIT_SUCCESS;
}

void print_array(int* ptr, int n) {
	for (int i = 0; i < n; ++i) {
		printf("%d ", ptr[i]);
	}
	printf("\n");
}

void reverse(int* pa, int n) {
	int i, j, t;
	for (i = 0, j = n-1; i < j; i++, j--) {
		t = pa[i];
		pa[i] = pa[j];
		pa[j] = t;
	}
}
