#include <stdio.h>
#include <time.h>
#include <stdlib.h>
enum { N = 5 };

//	in C const declarations do not produce constant expressions, i.e. in C you
//	can't use a const int object in a case label, as a bit-field width or as
//	array size

int main(void) {
	srand48(time(NULL));

	int array[N];
	for (int i = 0; i < N; i++)
		array[i] = (int) (lrand48() % 100);

	printf("Array version:\n");
	for (int i = 0; i < N; i++)
		printf("array[%d] = %d\n", i, array[i]);
	printf("\n");

	printf("Pointer version:\n");
	for (int i = 0; i < N; i++)
		printf("array[%d] = %d\n", i, *(array + i));
	printf("\n");

	printf("Another pointer version:\n");
	for (int *pa = array; pa < array + N; pa++)
		// t is a length modifier for ptrdiff_t
		printf("array[%td] = %d\n", pa - array, *pa);

	return EXIT_SUCCESS;
}

