#include "../includes/prompt_and_read.h"

enum { ROWS = 10, COLUMNS = 10 };

void set(int[][COLUMNS], int, int);
void print1(int[][COLUMNS], int, int);
void print2(const int*, int, int, int);

int main(void) {
	int arr2d[ROWS][COLUMNS];
	int rows = prompt_and_read_int("Enter no of rows");
	int cols = prompt_and_read_int("Enter no of cols");
	if (rows < 0 || rows >= ROWS || cols < 0 || cols >= COLUMNS) {
		error(1, errno, "dimension error");
	}

	set(arr2d, rows, cols);
	print1 (arr2d, rows, cols);
	print2 ((int*)arr2d, COLUMNS, rows, cols);

	return EXIT_SUCCESS;
}

void set(int arr2d[][COLUMNS], int rows, int cols) {
	for (int i = 0; i < rows; i++)
		for (int j = 0; j < cols; j++)
			arr2d[i][j] = cols * i + j;
}

// can print only arrays with COLUMNS cols
void print1(int arr2d[][COLUMNS], int rows, int cols) {
	for (int i = 0; i < rows; i++) {
		for (int j = 0; j < cols; j++) {
			printf("%4d", arr2d[i][j]);
		}
		printf("\n");
	}
	printf("\n");
}

// can print any 2D array
void print2(const int *pa, int cols_defined, int rows, int cols) {
	for (int i = 0; i < rows; i++) {
		for (int j = 0; j < cols; j++) {
			printf("%4d", *(pa + i * cols_defined + j));
		}
		printf("\n");
	}
	printf("\n");
}

