#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void print(char**);
void free_memory(char**);

int main(void) {
	enum { MAX_LINES = 256, BUF_LEN = 128 };

	char* lines[MAX_LINES] = { NULL };
	char buffer[BUF_LEN];
	int n = 0;

	while (n < MAX_LINES - 1 && fgets(buffer, BUF_LEN, stdin)) {
		lines[n++] = strdup(buffer);
	}
	printf("%d lines read\n\n", n);
	print(lines);
	free_memory(lines);

	return EXIT_SUCCESS;
}

void print(char** lines) {
	while(*lines) {
		printf("%p: %s", *lines, *lines);
		++lines;
	}
}

void free_memory(char** lines) {
	while(*lines) {
		free(*lines);
		*lines++ = NULL;
	}
}

