#include <stdio.h>
#include <stdlib.h>

//	This is a perfect example of undefined behavior. Which means that the
//	behaviour of such code is not defined in the C Language, and the output can
//	be anything, the program can print the old value of local it can print
//	garbage, the program can crash.

//	The value of a pointer becomes indeterminate when the object it points to
//	(or just past) reaches the end of its lifetime. local is automatic,
//	therefore its lifetime will end whenever the block in which it is defined
//	ends, which is actually the end of function return_local_pointer(). The local variables is
//	allocated in the stack frame created for the function return_local_pointer(). Whenever the
//	function returns, the current active stack frame becomes the stack frame of
//	the calling function (main(), in this case), and the stack frame area of
//	return_local_pointer() is no more allocated

int return_local() {
	int local = 1;
	printf("in return_local() = %d (%p)\n", local, &local);
	return local;
}

int* return_local_pointer() {
//	static
	int local = 2;
	printf("in return_local_pointer() = %d (%p)\n", local, &local);
	return &local;
}

int main(void) {

	printf("return_local() = %d\n", return_local());
	printf("--------------\n");

	int* p = return_local_pointer();
	printf("return_local_pointer() = %p\n", p);
	if(p) printf("return_local_pointer() = %d\n", *p);

	return EXIT_SUCCESS;
}

