#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void tabulate (const char*, double(*f)(double), double, double, double);
double some_function(double x) { return 1 / (1 + x * x); }

int main(void) {

	tabulate ("sin", sin, 0.0, M_PI, M_PI/10);
	tabulate ("exp", exp, 0.0, 1.0, 0.1);
	tabulate("some_function", some_function, 0.0, 1.0, 0.1);

	return EXIT_SUCCESS;
}

void tabulate (const char *name, double (*f)(double), double lower, double upper, double incr) {
	printf("%s():\n", name);
	printf("---------------------\n");
	int n = (int)((upper - lower) / incr);
	for (int i = 0; i < n; ++i) {
		double x = lower + i * incr;
		printf("%6.4f%10.4f\n", x, f(x));
	}
	printf("%6.4f%10.4f\n\n", upper, f(upper));
}

