#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int length_arr(const char*);
int length_ptr(const char*);
int length_ptr_compact(const char*);
int length_ptr_arith(const char*);
int string_comp(char*, char*);
char* string_copy(char*, char*);

int main(void) {

	char text[] = "some text";
	char text1[10];

	printf("text = %s\n", text);
	printf("length_arr = %d\n", length_arr(text));
	printf("length_ptr = %d\n", length_ptr(text));
	printf("length_ptr_compact = %d\n", length_ptr_compact(text));
	printf("length_ptr_arith = %d\n", length_ptr_arith(text));
	printf("strlen (system library) = %d\n", (int)strlen(text));
	printf("strlen(text+2) = %d\n", (int)strlen(text+2));
	printf("\n");

	string_copy(text1, text);
	printf("string_copy(text1, text)\n");
	printf("text1 = %s\n\n", text1);

	text1[0] = '\0';
	printf("text1 = %s\n", text1);
	strcpy(text1, text);
	printf("strcpy(text1, text) - system library \n");
	printf("text1 = %s\n\n", text1);

	text1[0] = '\0';
	int n_chars = 4;
	strncpy(text1, text, n_chars);
	text1[n_chars] = '\0';	//	strncpy does not produce null byte
	printf("strncpy(text1, text, %d)\n", n_chars);
	printf("text1 = %s\n\n", text1);

	char *td = strdup(text);
	printf("strdup (text) - system library \n");
	printf("text = %s\n", text);
	printf("td = %s\n", td);
	printf("string_comp(text, td) = %d\n", string_comp(text, td));
	printf("strcmp(text, td) = %d\n\n", strcmp(text, td));
	free(td);

	strcpy (text1, text);
	text1[4] = '_';
	printf("text = %s\n", text);
	printf("text1 = %s\n", text1);
	printf("string_comp(text, text1) = %d\n", string_comp(text, text1));
	printf("strcmp(text, text1) = %d\n", strcmp(text, text1));

	return EXIT_SUCCESS;
}

int length_arr(const char *s) {
	int n;
	for (n = 0; s[n] != '\0'; n++);
	return (n);
}

int length_ptr(const char *s) {
	int n;
	for (n = 0; *s != '\0'; s++, n++);
	return (n);
}

int length_ptr_compact(const char *s) {
	int n=0;
	while (*s++) n++;
	return (n);
}

int length_ptr_arith(const char *s) {
	const char *p = s;
	while (*p) p++;
	return (int)(p-s);
}

char *string_copy(char *s, char *t) {
	char *begin = s;
	while ((*s++ = *t++));
	return begin;
}

int string_comp(char *s, char *t) {
	for ( ;*s == *t; s++, t++)
		if (*s == '\0') return 0;
	return *s - *t;
}

